'Christmas Hope 2002
'by David Drake
'My gift for the LB community - December 2002
'Screenshot code borrowed from Kenneth J. Lewis, Sr..

    nomainwin
    loadbmp "manger","manger.bmp"
    loadbmp "star","star.bmp"
    loadbmp "angel","angel.bmp"
    loadbmp "text1","text1.bmp"
    loadbmp "text2","text2.bmp"
    for a = 1 to 18
        loadpic$ = "snow"+str$(a)+".bmp"
        mempic$ = "snow"+str$(a)
        loadbmp mempic$,loadpic$
    next a
    
    dim snowX(100)
    dim snowY(100)
    dim speedY(100)
    for a = 1 to 100
        snowX(a) = int(rnd(1)*DisplayWidth)
        snowY(a) = int(rnd(1)*DisplayHeight)
        speedY(a) = int(rnd(1)*5)+1
    next a
    
    maxY = DisplayHeight
    null$=chr$(0)
    
[getScreenShot]
    hdcScr=createDC("DISPLAY",null$,null$,null$)
    hdcCom=createCompatibleDC(hdcScr)
    hbmScr=createCompatibleBitmap(hdcScr,DisplayWidth,DisplayHeight)
    hmemBmp=selectObject(hdcCom,hbmScr)
    for y=1 to 1000:next y 'a delay to prevent a gray box where the window was (if hidden)
    call bitBlt hdcCom,0,0,DisplayWidth,DisplayHeight,hdcScr,0,0,_SRCCOPY
    hdcScr=selectObject(hdcCom,hmemBmp)
    LoadBmp "bg", hdcScr              'Alyce Watson and modified by me.
    call deleteObject hmemBmp
    call deleteDC hdcScr
    Call deleteDC hdcCom

[openMainWindow]
    graphicbox #main.gb, 0, 0, DisplayWidth, DisplayHeight
    WindowWidth = DisplayWidth
    WindowHeight = DisplayHeight
    UpperLeftX = 1
    UpperLeftY = 1
    open "Hope 2002" for window_popup as #main
    #main.gb "when leftButtonDown [quit]"
    #main.gb "background bg"
    for a = 1 to 100
        add$ = "addsprite snow"+str$(a)+" snow1 snow2 snow3 snow4 snow5 snow6 snow7 snow8 snow9 snow10 snow11 snow12 snow13 snow14 snow15 snow16 snow17 snow18"
        #main.gb add$
        #main.gb "spritevisible snow";a;" off"
        #main.gb "spritexy snow";a;" ";snowX(a);" ";snowY(a)
    next a
    #main.gb "addsprite manger manger"
    #main.gb "spritexy manger 2000 2000"
    #main.gb "addsprite star star"
    #main.gb "addsprite angel1 angel"
    #main.gb "addsprite angel2 angel"
    #main.gb "addsprite text1 text1"
    #main.gb "addsprite text2 text2"
    #main.gb "spritexy text1 2000 2000"
    #main.gb "spritexy text2 2000 2000"
    angel1X = 1
    angel2X = DisplayWidth - 150
    angel1Y = DisplayHeight - 200
    angel2Y = DisplayHeight - 200
    mangerX = DisplayWidth/2-434/2
    mangerY = DisplayHeight-392
    text1X = DisplayWidth/2-600/2
    text1Y = 200
    text2X = text1X
    text2Y = 230
    starX = DisplayWidth/2-150/2
    starY = 1
    #main.gb "spritexy star ";starX;" ";-100
    #main.gb "spritexy angel1 ";angel1X;" ";angel1Y
    #main.gb "spritexy angel2 ";angel2X;" ";angel2Y
    #main.gb "spriteorient angel1 mirror";

    textY = maxY + 100
    speedUp = 36
    while textY > 200
        textY = textY - speedUp
        speedUp = speedUp - 1
        if speedUp < 2 then speedUp = 2
        #main.gb "spritexy text1 ";text1X;" ";textY
        #main.gb "drawsprites"
        scan
    wend

    textY = maxY + 130
    speedUp = 36
    while textY > 230
        textY = textY - speedUp
        speedUp = speedUp - 1
        if speedUp < 2 then speedUp = 2
        #main.gb "spritexy text2 ";text2X;" ";textY
        #main.gb "drawsprites"
        scan
    wend

    for y = DisplayHeight+200 to mangerY step -15
        #main.gb "spritexy manger ";mangerX;" ";y
        #main.gb "drawsprites"
        scan
    next y

    for y = -100 to starY step 5
        #main.gb "spritexy star ";starX;" ";y
        #main.gb "drawsprites"
        scan
    next y

    for a = 1 to 100
        #main.gb "spritevisible snow";a;" on"
        if direction = 1 then direction = -1 else direction = 1
        #main.gb "cyclesprite snow";a;" ";direction
        #main.gb "drawsprites"
        scan
    next a

    timer 50, [animate]
wait

[animate]
    for a = 1 to 100
        snowY(a)=snowY(a)+speedY(a)
        if snowY(a) > maxY then snowY(a) = -50
        #main.gb "spritexy snow";a;" ";snowX(a);" ";snowY(a)
    next a
    #main.gb "drawsprites"
    scan
    wait

[quit]
    close #main
    unloadbmp "bg"
    unloadbmp "manger"
    unloadbmp "star"
    unloadbmp "angel"
    unloadbmp "text1"
    unloadbmp "text2"
    for a = 1 to 18
        mempic$ = "snow"+str$(a)
        unloadbmp mempic$
    next a
    end

'functions and subs down here
function createDC(lpDriverName$,lpDeviceName$,lpOutput$,lpInitData$)
    calldll #gdi32, "CreateDCA",_
        lpDriverName$ as ptr,_
        lpDeviceName$ as ptr,_
        lpOutput$ as ptr,_
        lpInitData$ as ptr,_
        ret as long
    createDC=ret
end function

function createCompatibleDC(hdc)
    calldll #gdi32,"CreateCompatibleDC",_
        hdc as long,_
        ret as long
    createCompatibleDC=ret
end function

function createCompatibleBitmap(hdc,nWidth,nHeight)
    calldll #gdi32,"CreateCompatibleBitmap",_
        hdc as long,_
        nWidth as long,_
        nHeight as long,_
        ret as long
    createCompatibleBitmap=ret
end function

function selectObject(hdc,hObject)
    calldll #gdi32,"SelectObject",_
        hdc as long,_
        hObject as long,_
        ret as long
    selectObject=ret
end function

sub bitBlt hDestDC,x,y,nWidth,nHeight,hSrcDC,xSrc,ySrc,dwRop
    calldll #gdi32,"BitBlt",_
        hDestDC as long,_
        x as long,_
        y as long,_
        nWidth as long,_
        nHeight as long,_
        hSrcDC as long,_
        xSrc as long,_
        ySrc as long,_
        dwRop as long,_
        ret as long
    print ret
end sub


sub deleteDC hdc
calldLL #gdi32,"DeleteDC",hdc as long, ret as boolean
end sub

Sub deleteObject hObject
CallDLL #gdi32,"DeleteObject",hObject As long,r As boolean
End Sub

